/*
 * Buffer.java
 *
 * Created on August 27, 2004, 5:45 PM
 */

package net.outer_planes.jso.ixp;


import java.io.ByteArrayOutputStream;
import java.io.IOException;

import org.jabberstudio.jso.io.StreamSource;

/**
 *
 * @author  linuxwolf
 * @version 0.13-DEV-20050624155226
 * @since   JSO-0.12
 */
public class Buffer {
    //"Constants"
    private static final int        BUFFER_SIZE = 8192;
    
    //Fields
    private StreamSource    _Src;
    private byte[]          _Data;
    private int             _End;
    private boolean         _EOF;

    //Constructors
    public Buffer(StreamSource src) {
        _Src = src;
        _Data = new byte[0];
    }
    
    //Methods
    public StreamSource getSource() {
        return _Src;
    }
    public byte[] getData() {
        return _Data;
    }
    public int getLength() {
        return _End;
    }
    public boolean isEOF() {
        return _EOF;
    }

    public void eat(int amt) {
        int     length = (_End - amt);

        if (length > 0) {
            System.arraycopy(_Data, amt, _Data, 0, length);
        }
        _End = length;
    }
    public void reset() {
        eat(getLength());
    }
    public void fill() throws IOException {
        byte[]  temp = new byte[BUFFER_SIZE];
        int     length;

        if (!isEOF()) {
            length = getSource().read(temp, 0, temp.length);
            if (length == -1)
                _EOF = true;
            else
                append(temp, 0, length);
        }
    }
    
    private void append(byte[] data, int offset, int length) {
        ByteArrayOutputStream   bout = new ByteArrayOutputStream();

        if (_End > 0)
            bout.write(_Data, 0, _End);
        bout.write(data, offset, length);

        _Data = bout.toByteArray();
        _End = _Data.length;
    }
}